#include "/lib/all_the_libs.glsl"

in vec2 texcoord;
flat in vec3 LightColorDirect;

#include "/generic/clouds.glsl"

/* DRAWBUFFERS:3 */
layout(location = 0) out vec4 CloudColor;

void main() {
    if (any(greaterThan(gl_FragCoord.xy, vec2(CLOUD_TEX_SIZE)))) {
        discard;
        return;
    }

    vec3 cameraPos = cameraPosition;
    cameraPos.xz += (gl_FragCoord.xy / CLOUD_TEX_SIZE * 2 - 1) * far * 4;
    vec3 PlayerPosN = vec3(0, 1, 0);

    CloudColor.rgb = get_clouds(PlayerPosN, vec3(0), 8, cameraPos, false);
}
